program Noname11;
uses crt;
const
  cmax=100;
  bereich=100;
type
  tInhalt=Integer;
  tFeld=array[1..cmax] of tInhalt;
  
procedure BubbleSort(var Feld : tFeld);
var
  i : integer;
  temp : tInhalt;
  fertig : boolean;

Begin;
  repeat
    fertig:=true;
    for i:=1 to cmax-1 do
    Begin
      if Feld[i] > Feld[i+1] then
      Begin
        temp:=Feld[i];
        Feld[i]:=Feld[i+1];
        Feld[i+1]:=temp;
        fertig:=false;
      End;
    End;
  until fertig=true;
End;

procedure BucketSort(var Feld : tFeld);
var
  Bucket : array[0..bereich] of tInhalt;
  I, J, Pos : LongInt;
begin
  for J := 0 to bereich do Bucket[J] := 0;
  (* Umschreiben des Feldes in den Bucket *)
  for I := 0 to cmax do Inc(Bucket[Feld[I]]);
  I := 1;
  J := 0;
  Pos := 0;
  for i:=0 to bereich do
  Begin
    J:=Bucket[I];
    While j > 0 do
    Begin
      Feld[Pos]:=I;
      Inc(pos);
      Dec(j);
    End;
  End;
end;

procedure mergesort(var Feld : tFeld; anfang, ende : integer);
var mitte : integer;

  procedure mischen(var Feld : tFeld; x,y,z : integer);
  var i,j,k : integer;
  begin
    for i:=y+1 to z do
    begin
      j:=i;
      k := Feld[i];
      while k > Feld[j-1] do
      begin
        Feld[j] := Feld[j-1];
        dec(j);
      end;
      Feld[j] := k;
    end;
  end;

begin
  if anfang < ende then
  begin
    (* rekursiver Abstieg - Teilfolgen*)
    mitte:=(anfang+ende)div 2;
    mergesort(Feld,anfang,mitte);
    mergesort(Feld,mitte+1,ende);
    (* rekursiver Aufstieg - Zusammenfgen *)
    mischen(Feld,anfang,mitte,ende);
  end;
end;

procedure QuickSort(var Feld : tFeld; Links, Rechts : Integer);
var
  i, j : LongInt;
  x, temp : tInhalt;

begin
  i := Links;
  j := Rechts;
  x := Feld[(Links + Rechts) div 2];
  repeat
    while Feld[i] < x do Inc(i);
    while Feld[j] > x do Dec(j);
    if i <= j then
    begin
      temp := Feld[i];
      Feld[i] := Feld[j];
      Feld[j] := temp;
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if Links < j then QuickSort(Feld, Links,j);
  if Rechts > i then QuickSort(Feld, i,Rechts);
end;


begin
  WriteLn('Hi!');
  Readln;
end.
